/*
   Copyright (c) 2014 by Plexim GmbH
   All rights reserved.

   A free license is granted to anyone to use this software for any legal
   non safety-critical purpose, including commercial applications, provided
   that:
   1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
   2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */

#ifndef CONTROL_H_
#define CONTROL_H_

#include "pil.h"

/* control tasks globals */
struct CONTROL_VARS {
	uint16_t backgroundTaskNumber;
	uint16_t task1StepCtr;
	uint16_t task2StepCtr;

	uint16_t Fs;
	PIL_OVERRIDE_PROBE(int16_t, Vsmax);
	PIL_OVERRIDE_PROBE(int16_t, IdSet);
	PIL_OVERRIDE_PROBE(int16_t, IqSet);
	PIL_OVERRIDE_PROBE(int16_t, we);
	PIL_OVERRIDE_PROBE(int16_t, IdErr);
	PIL_OVERRIDE_PROBE(int16_t, IqErr);
	PIL_OVERRIDE_PROBE(int16_t, Ia);
	PIL_OVERRIDE_PROBE(int16_t, Ib);
	PIL_OVERRIDE_PROBE(int16_t, Id);
	PIL_OVERRIDE_PROBE(int16_t, Iq);
	int16_t Vd;
	int16_t Vq;
	int16_t VdSat;
	int16_t VqSat;
	PIL_OVERRIDE_PROBE(int16_t, Va);
	PIL_OVERRIDE_PROBE(int16_t, Vb);
	uint16_t CmpU;
	uint16_t CmpV;
	uint16_t CmpW;
	PIL_OVERRIDE_PROBE(int16_t, svpwmLimitingGain);
	PIL_OVERRIDE_PROBE(uint16_t, fluxPosition);
	int16_t fluxPosSin;
	int16_t fluxPosCos;
};

extern struct CONTROL_VARS ControlVars;

extern void InitControl(void);
extern void DisableActuation(void);
extern void EnableActuation(void);
extern void ResetControl(void);

extern void ControlTask1(void);
extern void ControlTask2(void);
extern void ControlBackground(void);


#endif /*CONTROL_H_*/
