/*
   Copyright (c) 2014 by Plexim GmbH
   All rights reserved.

   A free license is granted to anyone to use this software for any legal
   non safety-critical purpose, including commercial applications, provided
   that:
   1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
   2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */

/**
 * @file svpwm.h
 * @brief Space-vector modulation module.
 */

#ifndef SVPWM_H_
#define SVPWM_H_

#include "plx_types.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct PLX_SVPWM_OBJ
{
	int16_t data[12];
} PLX_SVPWM_Obj_t;

typedef struct PLX_SVPWM_Obj_t *PLX_SVPWM_Handle_t;

extern PLX_SVPWM_Handle_t PLX_SVPWM_init(void *aMemory, const size_t aNumBytes);

extern void PLX_SVPWM_configure(PLX_SVPWM_Handle_t aSvpwmHandle,
		uint16_t aCounterPeriod, uint16_t aNumZeroVectors);

extern void PLX_SVPWM_calcCompareValues(PLX_SVPWM_Handle_t aSvpwmHandle,
		int16_t aVa, int16_t aVb, int16_t aVdc, uint16_t *aCmpU, uint16_t *aCmpV, uint16_t *aCmpW, int16_t *aLimiting);

#ifdef __cplusplus
}
#endif // extern "C"

#endif /* SVPWM_H_ */
