/*
 Copyright (c) 2014 by Plexim GmbH
 All rights reserved.

 NOTICE: This software embodies unpublished proprietary
 and trade secret information of Plexim GmbH.  Any copying,
 disclosure or transmission not expressly authorized by
 the owner is expressly prohibited. Plexim GmbH retains exclusive
 ownership of all intellectual property rights in this software,
 including all copyright, trade secret and patent rights.
 */

/**
 * @file fp_math.h
 * @brief Fixed-point math routines.
 */

#ifndef FP_MATH_H_
#define FP_MATH_H_

#include "plx_types.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int16_t PLX_FPMATH_divide(int16_t aN, int16_t aD, int16_t aQ);
extern int16_t PLX_FPMATH_divideAbsN(int16_t aN, int16_t aD, int16_t aQ);

extern void PLX_FPMATH_lookupSinAndCos(
    uint16_t aAngle, // angleIn, 360 degrees = 65536
    int16_t *aSin, // Sine output, Q15
    int16_t *aCos // Cosine output Q15
    );

extern int16_t PLX_FPMATH_sqrtQ10(int16_t aVal);

#ifdef __cplusplus
}
#endif // extern "C"

#endif /* FP_MATH_H_ */
